Index: applications/editors/josm/i18n/po/de.po
===================================================================
--- applications/editors/josm/i18n/po/de.po	(revision 12873)
+++ applications/editors/josm/i18n/po/de.po	(revision 12894)
@@ -8,6 +8,6 @@
 "Project-Id-Version: de\n"
 "Report-Msgid-Bugs-To: \n"
-"POT-Creation-Date: 2009-01-03 15:36+0100\n"
-"PO-Revision-Date: 2009-01-03 15:51+0100\n"
+"POT-Creation-Date: 2009-01-04 00:25+0100\n"
+"PO-Revision-Date: 2009-01-04 00:26+0100\n"
 "Last-Translator: Dirk Stöcker <openstreetmap@dstoecker.de>\n"
 "Language-Team: Deutsch\n"
@@ -3280,9 +3280,9 @@
 msgstr "Zeichenstil für den äußeren Weg ''{0}'' stimmt nicht überein."
 
-#: ../core/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java:760
+#: ../core/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java:770
 msgid "untagged"
 msgstr "Ohne Merkmale"
 
-#: ../core/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java:761
+#: ../core/src/org/openstreetmap/josm/data/osm/visitor/MapPaintVisitor.java:771
 msgid "text"
 msgstr "Text"
@@ -3656,5 +3656,7 @@
 "Error while exporting {0}:\n"
 "{1}"
-msgstr "Fehler beim Exportieren von {0}:\n{1}"
+msgstr ""
+"Fehler beim Exportieren von {0}:\n"
+"{1}"
 
 #: ../core/src/org/openstreetmap/josm/actions/GpxExportAction.java:192
@@ -5283,5 +5285,5 @@
 
 #: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerAction.java:286
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerReader.java:129
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerReader.java:112
 msgid "Lakewalker trace"
 msgstr "Lake Walker Spur"
@@ -5295,61 +5297,113 @@
 msgstr "Kann Bild nicht laden"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:36
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:18
+msgid "east"
+msgstr "Ost"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:18
+msgid "northeast"
+msgstr "Nordost"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:18
+msgid "north"
+msgstr "Nord"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:18
+msgid "northwest"
+msgstr "Nordwest"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:19
+msgid "west"
+msgstr "West"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:19
+msgid "southwest"
+msgstr "Südwest"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:19
+msgid "south"
+msgstr "Süd"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:19
+msgid "southeast"
+msgstr "Südost"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:21
+msgid "water"
+msgstr "Wasser"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:21
+msgid "coastline"
+msgstr "Küstenlinie"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:21
+msgid "land"
+msgstr "Land"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:21
+msgid "none"
+msgstr "Kein"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:40
 msgid "Maximum number of segments per way"
 msgstr "Maximale Anzahl von Abschnitten je Weg"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:38
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:42
 msgid "Maximum number of nodes in initial trace"
 msgstr "Maximale Anzahl von Knoten in der Anfangs-Spur"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:40
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:44
 msgid "Maximum gray value to count as water (0-255)"
 msgstr "Höchster Grauwert, der als Wasser betrachtet wird (0-255)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:42
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:46
 msgid "Line simplification accuracy (degrees)"
 msgstr "Genauigkeit beim Vereinfachen von Linien (Grad)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:44
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:48
 msgid "Resolution of Landsat tiles (pixels per degree)"
 msgstr "Auflösung der Landsat-Kacheln (Pixel pro Grad)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:46
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:50
 msgid "Size of Landsat tiles (pixels)"
 msgstr "Größe der Landsat-Kacheln (Pixel)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:48
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:52
 msgid "Shift all traces to east (degrees)"
 msgstr "Alle Spuren nach Osten verschieben (in Grad)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:50
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:54
 msgid "Shift all traces to north (degrees)"
 msgstr "Alle Spuren nach Norden verschieben (in Grad)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:52
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:56
 msgid "Direction to search for land"
 msgstr "Richtung, in der nach Land gesucht werden soll"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:54
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:58
 msgid "Tag ways as"
 msgstr "Wege bezeichnen als"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:56
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:60
 msgid "WMS Layer"
 msgstr "WMS-Ebene"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:58
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:62
 msgid "Maximum cache size (MB)"
 msgstr "Maximale Speichergröße (MB)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:60
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:64
 msgid "Maximum cache age (days)"
 msgstr "Maximales Speicheralter (Tage)"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:63
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:66
+msgid "Source text"
+msgstr "Datenquelle"
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:69
 msgid "Maximum number of segments allowed in each generated way. Default 250."
 msgstr "Maximale Anzahl von Abschnitten in jedem generierten Weg. Standard ist 250."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:64
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:70
 msgid ""
 "Maximum number of nodes to generate before bailing out (before simplifying "
@@ -5359,5 +5413,5 @@
 "Linien vereinfacht werden). Standardwert ist 50.000."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:65
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:71
 msgid ""
 "Maximum gray value to accept as water (based on Landsat IR-1 data). Can be "
@@ -5367,5 +5421,5 @@
 "Landsat IR-1-Daten). Erlaubter Bereich ist 0-255. Standard 90."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:66
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:72
 msgid ""
 "Accuracy of Douglas-Peucker line simplification, measured in degrees."
@@ -5376,5 +5430,5 @@
 "0.0003."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:67
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:73
 msgid "Resolution of Landsat tiles, measured in pixels per degree. Default 4000."
 msgstr ""
@@ -5382,21 +5436,21 @@
 "4.000."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:68
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:74
 msgid "Size of one landsat tile, measured in pixels. Default 2000."
 msgstr "Größe der Landsat-Kacheln, gemessen in Pixeln. Standard ist 2.000."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:69
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:75
 msgid "Offset all points in East direction (degrees). Default 0."
 msgstr "Alle Punkte nach Osten verschieben (Grad). Standard ist 0."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:70
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:76
 msgid "Offset all points in North direction (degrees). Default 0."
 msgstr "Alle Punkte nach Norden verschieben (Grad). Standard ist 0."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:71
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:77
 msgid "Direction to search for land. Default east."
 msgstr "Richtung in der nach Land gesucht werden soll. Standardmäßig Ost."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:72
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:78
 msgid "Tag ways as water, coastline, land or nothing. Default is water."
 msgstr ""
@@ -5404,21 +5458,25 @@
 "Wasser."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:73
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:79
 msgid "Which WMS layer to use for tracing against. Default is IR1."
 msgstr "Zum Abzeichnen genutzte WMS-Ebene. Standard ist IR1."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:74
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:80
 msgid "Maximum size of each cache directory in bytes. Default is 300MB"
 msgstr "Maximale Größe des Speicherverzeichnisses in Bytes. Standard ist 300MB"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:75
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:81
 msgid "Maximum age of each cached file in days. Default is 100"
 msgstr "Maximales Dateialter von gespeicherten Dateien in Tagen. Standard ist 100"
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:77
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:82
+msgid "Data source text. Default is Landsat."
+msgstr "Name der Datenquelle. Standardeinstellung ist Landsat."
+
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:84
 msgid "An plugin to trace water bodies on Landsat imagery."
 msgstr "Ein Plugin, um Wasserflächen auf Landsat-Bildern zu kennzeichnen."
 
-#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:78
+#: ../plugins/lakewalker/src/org/openstreetmap/josm/plugins/lakewalker/LakewalkerPreferences.java:85
 msgid "Lakewalker Plugin Preferences"
 msgstr "Einstellungen für das LakeWalker-Plugin"
@@ -5658,9 +5716,9 @@
 msgstr "Keine Fehler gefunden"
 
-#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:50
+#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:56
 msgid "Untagged, empty, and one node ways."
 msgstr "Leere Wege, 1-Knoten-Wege und Wege ohne Merkmale."
 
-#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:51
+#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:57
 msgid "This test checks for untagged, empty and one node ways."
 msgstr ""
@@ -5668,17 +5726,17 @@
 "Wege ohne Merkmale."
 
-#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:76
+#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:82
 msgid "Unnamed ways"
 msgstr "Unbenannte Wege"
 
-#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:83
+#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:89
 msgid "Untagged ways"
 msgstr "Wege ohne Merkmale"
 
-#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:88
+#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:94
 msgid "Empty ways"
 msgstr "Leere Wege"
 
-#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:92
+#: ../plugins/validator/src/org/openstreetmap/josm/plugins/validator/tests/UntaggedWay.java:98
 msgid "One node ways"
 msgstr "Wege, die nur aus einem Knoten bestehen"
@@ -6589,5 +6647,7 @@
 "\n"
 "{0} km/h"
-msgstr "\n{0} km/h"
+msgstr ""
+"\n"
+"{0} km/h"
 
 #: ../plugins/agpifoj/src/org/openstreetmap/josm/plugins/agpifoj/CorrelateGpxWithImages.java:144