Index: trunk/src/org/openstreetmap/josm/data/osm/DataSelectionListener.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/DataSelectionListener.java	(revision 12966)
+++ trunk/src/org/openstreetmap/josm/data/osm/DataSelectionListener.java	(revision 12970)
@@ -158,4 +158,9 @@
             }
             return added;
+        }
+
+        @Override
+        public String toString() {
+            return "SelectionReplaceEvent [current=" + current + ", removed=" + removed + ", added=" + added + ']';
         }
     }
@@ -202,4 +207,9 @@
         public Set<OsmPrimitive> getAdded() {
             return Collections.unmodifiableSet(add);
+        }
+
+        @Override
+        public String toString() {
+            return "SelectionAddEvent [add=" + add + ", current=" + current + ']';
         }
     }
@@ -247,4 +257,9 @@
         public Set<OsmPrimitive> getAdded() {
             return Collections.emptySet();
+        }
+
+        @Override
+        public String toString() {
+            return "SelectionRemoveEvent [remove=" + remove + ", current=" + current + ']';
         }
     }
@@ -298,4 +313,9 @@
             return Collections.unmodifiableSet(add);
         }
+
+        @Override
+        public String toString() {
+            return "SelectionToggleEvent [current=" + current + ", remove=" + remove + ", add=" + add + ']';
+        }
     }
 }
Index: trunk/src/org/openstreetmap/josm/data/osm/DataSet.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/DataSet.java	(revision 12966)
+++ trunk/src/org/openstreetmap/josm/data/osm/DataSet.java	(revision 12970)
@@ -207,5 +207,5 @@
         // the listener, projection change listeners are managed as WeakReferences.
         Main.addProjectionChangeListener(this);
-        addSelectionListener((DataSelectionListener) e -> fireDreprecatedSelectionChange(e.getSelection()));
+        addSelectionListener((DataSelectionListener) e -> fireDeprecatedSelectionChange(e.getSelection()));
     }
 
@@ -682,8 +682,8 @@
     @Deprecated
     public void fireSelectionChanged() {
-        fireDreprecatedSelectionChange(getAllSelected());
-    }
-
-    private static void fireDreprecatedSelectionChange(Collection<? extends OsmPrimitive> currentSelection) {
+        fireDeprecatedSelectionChange(getAllSelected());
+    }
+
+    private static void fireDeprecatedSelectionChange(Collection<? extends OsmPrimitive> currentSelection) {
         for (SelectionChangedListener l : selListeners) {
             l.selectionChanged(currentSelection);
Index: trunk/src/org/openstreetmap/josm/data/osm/event/SelectionEventManager.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/osm/event/SelectionEventManager.java	(revision 12966)
+++ trunk/src/org/openstreetmap/josm/data/osm/event/SelectionEventManager.java	(revision 12970)
@@ -178,7 +178,6 @@
             // If we would not do this, e.g. the move command would have a hard time tracking which layer
             // the last moved selection was in.
-            SelectionReplaceEvent event = new SelectionReplaceEvent(oldDataSet,
-                    new HashSet<>(oldDataSet.getAllSelected()), Stream.empty());
-            selectionChanged(event);
+            selectionChanged(new SelectionReplaceEvent(oldDataSet,
+                    new HashSet<>(oldDataSet.getAllSelected()), Stream.empty()));
             oldDataSet.removeSelectionListener(this);
         }
@@ -187,7 +186,6 @@
             newDataSet.addSelectionListener(this);
             // Fake a selection add
-            SelectionReplaceEvent event = new SelectionReplaceEvent(newDataSet,
-                    Collections.emptySet(), newDataSet.getAllSelected().stream());
-            selectionChanged(event);
+            selectionChanged(new SelectionReplaceEvent(newDataSet,
+                    Collections.emptySet(), newDataSet.getAllSelected().stream()));
         }
     }