Index: trunk/src/org/openstreetmap/josm/io/AbstractReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/AbstractReader.java	(revision 13194)
+++ trunk/src/org/openstreetmap/josm/io/AbstractReader.java	(revision 13196)
@@ -95,6 +95,6 @@
                         throw new IllegalDataException(
                                 tr("Way with external ID ''{0}'' includes missing node with external ID ''{1}''.",
-                                        externalWayId,
-                                        id));
+                                        Long.toString(externalWayId),
+                                        Long.toString(id)));
                     // create an incomplete node if necessary
                     n = (Node) ds.getPrimitiveById(id, OsmPrimitiveType.NODE);
@@ -105,5 +105,5 @@
                 }
                 if (n.isDeleted()) {
-                    Logging.info(tr("Deleted node {0} is part of way {1}", id, w.getId()));
+                    Logging.info(tr("Deleted node {0} is part of way {1}", Long.toString(id), Long.toString(w.getId())));
                 } else {
                     wayNodes.add(n);
@@ -113,5 +113,5 @@
             if (w.hasIncompleteNodes()) {
                 Logging.info(tr("Way {0} with {1} nodes has incomplete nodes because at least one node was missing in the loaded data.",
-                          externalWayId, w.getNodesCount()));
+                        Long.toString(externalWayId), w.getNodesCount()));
             }
             ds.addPrimitive(w);
@@ -153,6 +153,6 @@
                         throw new IllegalDataException(
                                 tr("Relation with external id ''{0}'' refers to a missing primitive with external id ''{1}''.",
-                                        externalRelationId,
-                                        rm.getMemberId()));
+                                        Long.toString(externalRelationId),
+                                        Long.toString(rm.getMemberId())));
 
                     // member refers to OSM primitive which was not present in the parsed data
@@ -176,5 +176,6 @@
                 }
                 if (primitive.isDeleted()) {
-                    Logging.info(tr("Deleted member {0} is used by relation {1}", primitive.getId(), relation.getId()));
+                    Logging.info(tr("Deleted member {0} is used by relation {1}",
+                            Long.toString(primitive.getId()), Long.toString(relation.getId())));
                 } else {
                     relationMembers.add(new RelationMember(rm.getRole(), primitive));
Index: trunk/src/org/openstreetmap/josm/io/OsmReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmReader.java	(revision 13194)
+++ trunk/src/org/openstreetmap/josm/io/OsmReader.java	(revision 13196)
@@ -277,5 +277,5 @@
         }
         if (w.isDeleted() && !nodeIds.isEmpty()) {
-            Logging.info(tr("Deleted way {0} contains nodes", w.getUniqueId()));
+            Logging.info(tr("Deleted way {0} contains nodes", Long.toString(w.getUniqueId())));
             nodeIds = new ArrayList<>();
         }
@@ -287,5 +287,5 @@
         if (parser.getAttributeValue(null, "ref") == null) {
             throwException(
-                    tr("Missing mandatory attribute ''{0}'' on <nd> of way {1}.", "ref", w.getUniqueId())
+                    tr("Missing mandatory attribute ''{0}'' on <nd> of way {1}.", "ref", Long.toString(w.getUniqueId()))
             );
         }
@@ -293,5 +293,5 @@
         if (id == 0) {
             throwException(
-                    tr("Illegal value of attribute ''ref'' of element <nd>. Got {0}.", id)
+                    tr("Illegal value of attribute ''ref'' of element <nd>. Got {0}.", Long.toString(id))
             );
         }
@@ -327,5 +327,5 @@
         }
         if (r.isDeleted() && !members.isEmpty()) {
-            Logging.info(tr("Deleted relation {0} contains members", r.getUniqueId()));
+            Logging.info(tr("Deleted relation {0} contains members", Long.toString(r.getUniqueId())));
             members = new ArrayList<>();
         }
@@ -339,5 +339,5 @@
         String value = parser.getAttributeValue(null, "ref");
         if (value == null) {
-            throwException(tr("Missing attribute ''ref'' on member in relation {0}.", r.getUniqueId()));
+            throwException(tr("Missing attribute ''ref'' on member in relation {0}.", Long.toString(r.getUniqueId())));
         }
         try {