Index: trunk/data/boundaries.osm
===================================================================
--- trunk/data/boundaries.osm	(revision 13389)
+++ trunk/data/boundaries.osm	(revision 13412)
@@ -39566,5 +39566,5 @@
     <nd ref='-11952' />
     <tag k='ISO3166-1:alpha2' v='TW' />
-    <tag k='ISO3166-2' v='CN-71' />
+    <tag k='ISO3166-2' v='CN-TW' />
     <tag k='name:en' v='Taiwan' />
     <tag k='note' v='Self admin.; Claimed by China' />
@@ -43864,5 +43864,5 @@
     <nd ref='-22518' />
     <tag k='ISO3166-1:alpha2' v='HK' />
-    <tag k='ISO3166-2' v='CN-91' />
+    <tag k='ISO3166-2' v='CN-HK' />
     <tag k='driving_side' v='left' />
     <tag k='name:en' v='Hong Kong' />
@@ -43936,5 +43936,5 @@
     <nd ref='-22582' />
     <tag k='ISO3166-1:alpha2' v='MO' />
-    <tag k='ISO3166-2' v='CN-92' />
+    <tag k='ISO3166-2' v='CN-MO' />
     <tag k='driving_side' v='left' />
     <tag k='name:en' v='Macau' />
@@ -50477,5 +50477,5 @@
     <nd ref='-22186' />
     <nd ref='-22190' />
-    <tag k='ISO3166-2' v='CN-54' />
+    <tag k='ISO3166-2' v='CN-XZ' />
     <tag k='name:en' v='Tibet' />
   </way>
@@ -50693,5 +50693,5 @@
     <nd ref='-85124' />
     <nd ref='-85126' />
-    <tag k='ISO3166-2' v='CN-65' />
+    <tag k='ISO3166-2' v='CN-XJ' />
     <tag k='name:en' v='Xinjiang' />
   </way>
@@ -51031,5 +51031,5 @@
     <nd ref='-13018' />
     <nd ref='-7972' />
-    <tag k='ISO3166-2' v='CN-15' />
+    <tag k='ISO3166-2' v='CN-NM' />
     <tag k='name:en' v='Inner Mongolia' />
   </way>
@@ -51191,5 +51191,5 @@
     <nd ref='-85286' />
     <nd ref='-85288' />
-    <tag k='ISO3166-2' v='CN-63' />
+    <tag k='ISO3166-2' v='CN-QH' />
     <tag k='name:en' v='Qinghai' />
   </way>
@@ -51396,5 +51396,5 @@
     <nd ref='-2550' />
     <nd ref='-2504' />
-    <tag k='ISO3166-2' v='CN-45' />
+    <tag k='ISO3166-2' v='CN-GX' />
     <tag k='name:en' v='Guangxi' />
   </way>
@@ -51763,5 +51763,5 @@
     <nd ref='-87374' />
     <nd ref='-87376' />
-    <tag k='ISO3166-2' v='CN-53' />
+    <tag k='ISO3166-2' v='CN-YN' />
     <tag k='name:en' v='Yunnan' />
   </way>
@@ -51961,5 +51961,5 @@
     <nd ref='-86947' />
     <nd ref='-86949' />
-    <tag k='ISO3166-2' v='CN-51' />
+    <tag k='ISO3166-2' v='CN-SC' />
     <tag k='name:en' v='Sichuan' />
   </way>
@@ -52105,5 +52105,5 @@
     <nd ref='-89340' />
     <nd ref='-89338' />
-    <tag k='ISO3166-2' v='CN-62' />
+    <tag k='ISO3166-2' v='CN-GS' />
     <tag k='name:en' v='Gansu' />
   </way>
@@ -52138,5 +52138,5 @@
     <nd ref='-90113' />
     <nd ref='-90115' />
-    <tag k='ISO3166-2' v='CN-64' />
+    <tag k='ISO3166-2' v='CN-NX' />
     <tag k='name:en' v='Ningxia' />
   </way>
@@ -52271,5 +52271,5 @@
     <nd ref='-86295' />
     <nd ref='-86297' />
-    <tag k='ISO3166-2' v='CN-23' />
+    <tag k='ISO3166-2' v='CN-HL' />
     <tag k='name:en' v='Heilongjiang' />
   </way>
@@ -52403,5 +52403,5 @@
     <nd ref='-86345' />
     <nd ref='-86347' />
-    <tag k='ISO3166-2' v='CN-22' />
+    <tag k='ISO3166-2' v='CN-JL' />
     <tag k='name:en' v='Jilin' />
   </way>
@@ -52487,5 +52487,5 @@
     <nd ref='-12220' />
     <nd ref='-10870' />
-    <tag k='ISO3166-2' v='CN-21' />
+    <tag k='ISO3166-2' v='CN-LN' />
     <tag k='name:en' v='Liaoning' />
   </way>
@@ -56386,5 +56386,5 @@
     <nd ref='-90193' />
     <nd ref='-90195' />
-    <tag k='ISO3166-2' v='CN-61' />
+    <tag k='ISO3166-2' v='CN-SN' />
     <tag k='name:en' v='Shaanxi' />
   </way>
@@ -56571,5 +56571,5 @@
     <nd ref='-87464' />
     <nd ref='-87466' />
-    <tag k='ISO3166-2' v='CN-52' />
+    <tag k='ISO3166-2' v='CN-GZ' />
     <tag k='name:en' v='Guizhou' />
   </way>
@@ -56728,5 +56728,5 @@
     <nd ref='-99017' />
     <nd ref='-99011' />
-    <tag k='ISO3166-2' v='CN-50' />
+    <tag k='ISO3166-2' v='CN-CQ' />
     <tag k='name:en' v='Chongqing' />
   </way>
@@ -56738,5 +56738,5 @@
     <nd ref='-11958' />
     <nd ref='-11960' />
-    <tag k='ISO3166-2' v='CN-46' />
+    <tag k='ISO3166-2' v='CN-HI' />
     <tag k='name:en' v='Hainan' />
   </way>
@@ -57007,5 +57007,5 @@
     <nd ref='-98985' />
     <nd ref='-99758' />
-    <tag k='ISO3166-2' v='CN-43' />
+    <tag k='ISO3166-2' v='CN-HN' />
     <tag k='name:en' v='Hunan' />
   </way>
@@ -57158,5 +57158,5 @@
     <nd ref='-98765' />
     <nd ref='-98767' />
-    <tag k='ISO3166-2' v='CN-42' />
+    <tag k='ISO3166-2' v='CN-HB' />
     <tag k='name:en' v='Hubei' />
   </way>
@@ -57263,5 +57263,5 @@
     <nd ref='-98777' />
     <nd ref='-98779' />
-    <tag k='ISO3166-2' v='CN-41' />
+    <tag k='ISO3166-2' v='CN-HA' />
     <tag k='name:en' v='Henan' />
   </way>
@@ -57321,5 +57321,5 @@
     <nd ref='-10870' />
     <nd ref='-90624' />
-    <tag k='ISO3166-2' v='CN-37' />
+    <tag k='ISO3166-2' v='CN-SD' />
     <tag k='name:en' v='Shandong' />
   </way>
@@ -57443,5 +57443,5 @@
     <nd ref='-99569' />
     <nd ref='-99567' />
-    <tag k='ISO3166-2' v='CN-36' />
+    <tag k='ISO3166-2' v='CN-JX' />
     <tag k='name:en' v='Jiangxi' />
   </way>
@@ -57566,5 +57566,5 @@
     <nd ref='-100569' />
     <nd ref='-100564' />
-    <tag k='ISO3166-2' v='CN-34' />
+    <tag k='ISO3166-2' v='CN-AH' />
     <tag k='name:en' v='Anhui' />
   </way>
@@ -57643,5 +57643,5 @@
     <nd ref='-99519' />
     <nd ref='-99515' />
-    <tag k='ISO3166-2' v='CN-35' />
+    <tag k='ISO3166-2' v='CN-FJ' />
     <tag k='name:en' v='Fujian' />
   </way>
@@ -57716,5 +57716,5 @@
     <nd ref='-100689' />
     <nd ref='-11942' />
-    <tag k='ISO3166-2' v='CN-33' />
+    <tag k='ISO3166-2' v='CN-ZJ' />
     <tag k='name:en' v='Zhejiang' />
   </way>
@@ -57814,5 +57814,5 @@
     <nd ref='-100988' />
     <nd ref='-100986' />
-    <tag k='ISO3166-2' v='CN-32' />
+    <tag k='ISO3166-2' v='CN-JS' />
     <tag k='name:en' v='Jiangsu' />
   </way>
@@ -57851,5 +57851,5 @@
     <nd ref='-101118' />
     <nd ref='-11942' />
-    <tag k='ISO3166-2' v='CN-31' />
+    <tag k='ISO3166-2' v='CN-SH' />
     <tag k='name:en' v='Shanghai' />
   </way>
@@ -57944,5 +57944,5 @@
     <nd ref='-100209' />
     <nd ref='-98779' />
-    <tag k='ISO3166-2' v='CN-14' />
+    <tag k='ISO3166-2' v='CN-SX' />
     <tag k='name:en' v='Shanxi' />
   </way>
@@ -58139,5 +58139,5 @@
     <nd ref='-101380' />
     <nd ref='-101382' />
-    <tag k='ISO3166-2' v='CN-13' />
+    <tag k='ISO3166-2' v='CN-HE' />
     <tag k='name:en' v='Hebei' />
   </way>
@@ -58193,5 +58193,5 @@
     <nd ref='-101435' />
     <nd ref='-101433' />
-    <tag k='ISO3166-2' v='CN-12' />
+    <tag k='ISO3166-2' v='CN-TJ' />
     <tag k='name:en' v='Tianjin' />
   </way>
@@ -58263,5 +58263,5 @@
     <nd ref='-101581' />
     <nd ref='-101731' />
-    <tag k='ISO3166-2' v='CN-11' />
+    <tag k='ISO3166-2' v='CN-BJ' />
     <tag k='name:en' v='Beijing' />
   </way>
@@ -58716,5 +58716,5 @@
     <member type='way' ref='-29370' role='inner' />
     <member type='way' ref='-29384' role='inner' />
-    <tag k='ISO3166-2' v='CN-44' />
+    <tag k='ISO3166-2' v='CN-GD' />
     <tag k='name:en' v='Guangdong' />
     <tag k='type' v='multipolygon' />